package edu.lawrence.hotelfx;

import java.net.URL;
import java.util.ResourceBundle;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.TextField;
import edu.lawrence.hotel.Room;
import edu.lawrence.hotel.Reservation;
import java.time.LocalDate;
import javafx.scene.control.Label;

/**
 * FXML Controller class
 *
 * @author Joe Gregg
 */
public class FXMLNewReservationDialogController implements Initializable {
    private Room room;
    private LocalDate date;
    
    @FXML
    private TextField reservationNumber;
    @FXML
    private TextField customerNumber;
    @FXML
    private TextField groupSize;
    @FXML
    private TextField startTime;
    @FXML
    private TextField endTime;
    @FXML
    private void cancelDialog(ActionEvent event) {
        reservationNumber.getScene().getWindow().hide();
    }
    @FXML
    private Label errorText;
    
    @FXML
    private void acceptDialog(ActionEvent event) {
        int rsvNumber = Integer.parseInt(reservationNumber.getText());
        int custNumber = Integer.parseInt(customerNumber.getText());
        int start = Integer.parseInt(startTime.getText());
        int end = Integer.parseInt(endTime.getText());
        int size = Integer.parseInt(groupSize.getText());
        Reservation newReservation = new Reservation(rsvNumber,custNumber,date,start,end,size);
        if(room.allowsReservation(newReservation)) {
            room.addReservation(newReservation);
            reservationNumber.getScene().getWindow().hide();
        } else
            errorText.setText("The reservation can not be scheduled.");
    }
    
    @Override
    public void initialize(URL url, ResourceBundle rb) {
        // TODO
    }    
    
    public void setRoom(Room room) {
        this.room = room;
    }
    
    public void setDate(LocalDate date) {
        this.date = date;
    }
}
